using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace sharpserver
{
    class CloseButton : Button
    {
        private Brush myBrush = Brushes.Black;
        private ToolTip tip = new ToolTip();

        protected override void OnPaint(PaintEventArgs pevent)
        {
            base.OnPaint(pevent);

            Graphics g = pevent.Graphics;
            Rectangle r = new Rectangle(0, 0, this.Width - 1, this.Height - 1);
            g.FillRectangle(Brushes.LightGray, new Rectangle(0, 0, this.Width, this.Height));
            g.DrawEllipse(new Pen(myBrush, 2), 2, 2, this.Width - 5, this.Height - 5);
            g.DrawLine(new Pen(myBrush, 2), new Point(7, 7), new Point(this.Width - 8, this.Height - 8));
            g.DrawLine(new Pen(myBrush, 2), new Point(7, this.Height - 8), new Point(this.Width - 8, 7));
        }

        protected override void OnMouseEnter(EventArgs e)
        {
            base.OnMouseEnter(e);

            this.myBrush = Brushes.Red;
            this.Invalidate();
            this.tip.Show("Close sb0t", this);
        }

        protected override void OnMouseLeave(EventArgs e)
        {
            base.OnMouseLeave(e);

            this.myBrush = Brushes.Black;
            this.Invalidate();
            this.tip.Hide(this);
        }
    }
}
