using System;
using System.Collections.Generic;
using System.Text;
using System.Net;

namespace cb0tServer
{
    class Lowers
    {
        private static List<MuzzledUserItem> lower_items = new List<MuzzledUserItem>();

        public static bool IsLowered(UserObject userobj)
        {
            foreach (MuzzledUserItem m in lower_items)
            {
                if (m.guid.Equals(userobj.guid) || m.ip.Equals(userobj.physical_ip))
                {
                    return true;
                }
            }

            return false;
        }

        public static void AddLower(UserObject userobj)
        {
            foreach (MuzzledUserItem m in lower_items)
            {
                if (m.guid.Equals(userobj.guid) ||
                    m.ip.Equals(userobj.physical_ip))
                {
                    return;
                }
            }

            MuzzledUserItem mu = new MuzzledUserItem();
            mu.name = userobj.name;
            mu.guid = userobj.guid;
            mu.ip = userobj.physical_ip;
            mu.muzzle_time = (int)cb0tServer.Helpers.UnixTime();
            lower_items.Add(mu);
        }

        public static void RemLower(UserObject userobj)
        {
            for (int i = 0; i < lower_items.Count; i++)
            {
                if (lower_items[i].guid.Equals(userobj.guid) ||
                    lower_items[i].ip.Equals(userobj.physical_ip))
                {
                    lower_items.RemoveAt(i);
                    return;
                }
            }
        }

        public static void ClearLowers()
        {
            lower_items.Clear();

            foreach (UserObject u in UserPool.Users)
            {
                if (u.IsSet())
                {
                    if (u.logged_in)
                    {
                        if (u.lowered)
                        {
                            u.lowered = false;
                        }
                    }
                }
            }
        }
    }
}
